searchNodes=[{"doc":"PhxLiveStorybook provides a storybook-like UI interface for your Phoenix LiveView components. Explore all your components, and showcase them with different variations. Browse your components documentation, with their supported attributes ( soon ). Learn how components behave by using an interactive playground ( soon ). How does it work? PhxLiveStorybook is mounted in your application router and serves its UI at the mounting point of your choice. It performs an automatic discovery of your storybook content under a specified folder ( :content_path ) and then automatically generate storybook navigation sidebar. Every module detected in your content folder, will be loaded and identified as a storybook entry. Three kind of entries are supported: component to describe your stateless function components. live_component to describe your live components. page to write &amp; document UI guidelines, or whatever content you want. Almost everything, from sidebar rendering to component preview, is performed at compilation time. Installation To start using PhxLiveStorybook in your phoenix application you will need to follow these steps: Add the phx_live_storybook dependency Create your storybook backend module Add storybook access in your router Make your components assets available Configure your storybook Create some content. 1. Add the phx_live_storybook dependency Add the following to your mix.exs and run mix deps.get: def deps do [ { :phx_live_storybook , &quot;~&gt; 0.2.0&quot; } ] end 2. Create your storybook backend module Create a new module under your application lib folder. # lib/my_app_web/storybook.ex defmodule MyAppWeb.Storybook do use PhxLiveStorybook , otp_app : :my_app end This backend module ensures the storybook gets recompiled as soon as you update your storybook content (see section 5.) 3. Add storybook access in your router Once installed, update your router's configuration to forward requests to a PhxLiveStorybook with a unique name of your choosing: # lib/my_app_web/router.ex use MyAppWeb , :router import PhxLiveStorybook.Router ... scope &quot;/&quot; do pipe_through :browser live_storybook &quot;/storybook&quot; , otp_app : :my_app , backend_module : MyAppWeb.Storybook end 4. Make your components assets available Build a new css bundle dedicated to your live_view components: this bundle will be used both by your app and the storybook. In this README, we use assets/css/my_components.css as an example. If your components require any hooks or custom uploaders, declare them as such in a new JS bundle: // assets/js/my_components.js import * as Hooks from &quot;./hooks&quot;; import * as Uploaders from &quot;./uploaders&quot;; (function () { window.storybook = { Hooks, Uploaders }; })(); 5. Configure your storybook In your configuration files, add the following. # config/config.exs config :my_app , MyAppWeb.Storybook , content_path : Path . expand ( &quot;../my_app_web/lib/storybook&quot; , __DIR__ ) , css_path : &quot;/assets/my_components.css&quot; , js_path : &quot;/assets/my_components.js&quot; 6. Create some content. Then you can start creating some content for your storybook. Storybook can contain 3 different kind of entries : component entries : to document and showcase your components. pages : to publish some UI guidelines, framework or whatever with regular HTML content. samples : to show how your components can be used and mixed togethers in real UI pages. As of 0.2.0 , only component entries are available. Entries are described as regular Elixir modules, created under your :content_path folder. Feel free to organize them in sub-folders, as the hierarchy will be respected in your storybook sidebar. Here is an example of a stateless (function) component entry: # lib/my_app_web/storybook/components/button.ex defmodule MyAppWeb.Storybook.Components.Button do alias MyAppWeb.Components.Button # :live_component is also available use PhxLiveStorybook.Entry , :component def component , do : Button def function , do : &amp; Button . button / 1 def description , do : &quot;A simple generic button.&quot; def variations do [ % Variation { id : :default , attributes : %{ label : &quot;A button&quot; } } , % Variation { id : :green_button , attributes : %{ :label =&gt; &quot;Still a button&quot; , :&quot;bg-color&quot; =&gt; &quot;bg-green-600&quot; , :&quot;hover-bg-color&quot; =&gt; &quot;bg-green-700&quot; } } ] end end Configuration All config settings, only the :content_path key is mandatory. # config/config.exs config :my_app , MyAppWeb.Storybook , # Path to your storybook entries (required). content_path : Path . expand ( &quot;../my_app_web/lib/storybook&quot; , __DIR__ ) , # Each entry module is loaded from camelized HTTP request path (ie. `&quot;/components/button&quot;`) # prefixed by the following. Default is your backend module. entries_module_prefix : MyAppWeb.Storybook , # Path to your components stylesheet. css_path : &quot;/assets/my_components.css&quot; , # Path to your JS asset, which will be loaded just before PhxLiveStorybook&#39;s own # JS. It&#39;s mainly intended to define your own LiveView Hooks in `window.storybook.Hooks`. js_path : &quot;/assets/my_components.js&quot; , # Custom storybook title. Default is &quot;Live Storybook&quot;. title : &quot;My Live Storybook&quot; , # Folder settings. # Each folder is designated by its relative path from the storybook mounting point. # For each folder you can: # - make it open by defaut in the sidebar, with `open: true`. # - give it a custom name in the sidebar # - give it a custom icon in the sidebar, with a FontAwesome 6+ CSS class. folders : [ &quot;/&quot; : [ icon : &quot;fas fa-banana&quot; ] , &quot;/components&quot; : [ icon : &quot;far fa-toolbox&quot; , open : true ] , &quot;components/live&quot; : [ icon : &quot;fal fa-bolt&quot; , name : &quot;Live!!!&quot; ] ]","ref":"PhxLiveStorybook.html","title":"PhxLiveStorybook","type":"module"},{"doc":"Behaviour implemented by your backend module. Most of it is precompiled through macros.","ref":"PhxLiveStorybook.BackendBehaviour.html","title":"PhxLiveStorybook.BackendBehaviour","type":"behaviour"},{"doc":"Returns a configuration value from your config.exs storybook settings. key is the config key default is an optional default value if no value can be fetched.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:config/2","title":"PhxLiveStorybook.BackendBehaviour.config/2","type":"callback"},{"doc":"Returns the first leaf of the storybook content tree (ie. whichever entry which is not a folder)","ref":"PhxLiveStorybook.BackendBehaviour.html#c:path_to_first_leaf_entry/0","title":"PhxLiveStorybook.BackendBehaviour.path_to_first_leaf_entry/0","type":"callback"},{"doc":"Renders code snippet of a specific variation for a given component entry. Returns rendered HEEx template.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:render_code/2","title":"PhxLiveStorybook.BackendBehaviour.render_code/2","type":"callback"},{"doc":"Renders source of a component entry. Returns rendered HEEx template.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:render_source/1","title":"PhxLiveStorybook.BackendBehaviour.render_source/1","type":"callback"},{"doc":"Renders a specific variation for a given component entry. Can be a single variation or a variation group. Returns rendered HEEx template.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:render_variation/2","title":"PhxLiveStorybook.BackendBehaviour.render_variation/2","type":"callback"},{"doc":"Returns a precompiled tree of your storybook entries.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:storybook_entries/0","title":"PhxLiveStorybook.BackendBehaviour.storybook_entries/0","type":"callback"},{"doc":"An entry designates any kind of content in your storybook. For now only following kinds of entries are supported: component , :live_component , and :page . In order to populate your storybook, just create entry modules under your content path, and implement their required behaviour. Usage Component Implement your component as such. Confer to PhxLiveStorybook.Variation documentation for variations. defmodule MyAppWeb.Storybook.MyComponent do use PhxLiveStorybook.Entry , :component # required def component , do : MyAppWeb.MyComponent # required def function , do : &amp; MyAppWeb.MyComponent . my_component / 1 def name , do : &quot;Another name for my component&quot; def description , do : &quot;My component description&quot; def icon , do : &quot;fa fa-icon&quot; def variations , do : [ ] end Live Component Very similar components, excepted the function/0 callback no longer required. defmodule MyAppWeb.Storybook.MyLiveComponent do use PhxLiveStorybook.Entry , :live_component # required def component , do : MyAppWeb.MyLiveComponent def name , do : &quot;Another name for my component&quot; def description , do : &quot;My live component description&quot; def icon , do : &quot;fa fa-icon&quot; def variations , do : [ ] end Page A page is basically a LiveComponent that can be used to write whatever content you want. We use it to provide some UI guidelines. You should implement the render function and an optional navigation function, if you want a tab based sub-navigation. Current tab is passed as :tab in render/1 assigns. defmodule MyAppWeb.Storybook.MyPage do use PhxLiveStorybook.Entry , :page def name , do : &quot;Another name for my page&quot; def description , do : &quot;My page description&quot; def icon , do : &quot;fa fa-icon&quot; def navigation do [ { :tab_id , &quot;Tab Name&quot; , &quot;tab-icon&quot; } , { :tab_id , &quot;Tab Name&quot; , &quot;tab-icon&quot; } ] end def render ( assigns ) do ~H&quot;&quot;&quot; &lt;div&gt;Your HEEX template&lt;/div&gt; &quot;&quot;&quot; end end","ref":"PhxLiveStorybook.Entry.html","title":"PhxLiveStorybook.Entry","type":"module"},{"doc":"Convenience helper for using the functions above.","ref":"PhxLiveStorybook.Entry.html#__using__/1","title":"PhxLiveStorybook.Entry.__using__/1","type":"macro"},{"doc":"Responsible for rendering your components code snippet, for a given PhxLiveStorybook.Variation . Uses Makeup libray for syntax highlighting.","ref":"PhxLiveStorybook.Rendering.CodeRenderer.html","title":"PhxLiveStorybook.Rendering.CodeRenderer","type":"module"},{"doc":"Renders a function component code snippet, wrapped in a &lt;pre&gt; tag.","ref":"PhxLiveStorybook.Rendering.CodeRenderer.html#render_component_code/3","title":"PhxLiveStorybook.Rendering.CodeRenderer.render_component_code/3","type":"function"},{"doc":"Renders a component's (live or not) source code, wrapped in a &lt;pre&gt; tag.","ref":"PhxLiveStorybook.Rendering.CodeRenderer.html#render_component_source/2","title":"PhxLiveStorybook.Rendering.CodeRenderer.render_component_source/2","type":"function"},{"doc":"Renders a live component code snippet, wrapped in a &lt;pre&gt; tag.","ref":"PhxLiveStorybook.Rendering.CodeRenderer.html#render_live_component_code/3","title":"PhxLiveStorybook.Rendering.CodeRenderer.render_live_component_code/3","type":"function"},{"doc":"Responsible for rendering your function &amp; live components, for a given PhxLiveStorybook.Variation .","ref":"PhxLiveStorybook.Rendering.ComponentRenderer.html","title":"PhxLiveStorybook.Rendering.ComponentRenderer","type":"module"},{"doc":"Render a live component, with or without block / slots.","ref":"PhxLiveStorybook.Rendering.ComponentRenderer.html#render_variation/3","title":"PhxLiveStorybook.Rendering.ComponentRenderer.render_variation/3","type":"function"},{"doc":"Renders a variation of stateless function component, with or without block / slots.","ref":"PhxLiveStorybook.Rendering.ComponentRenderer.html#render_variation/4","title":"PhxLiveStorybook.Rendering.ComponentRenderer.render_variation/4","type":"function"},{"doc":"Provides LiveView routing for storybook.","ref":"PhxLiveStorybook.Router.html","title":"PhxLiveStorybook.Router","type":"module"},{"doc":"Defines a PhxLiveStorybook route. It expects the path the storybook will be mounted at and a set of options. This will also generate a named helper called live_dashboard_path/2 which you can use to link directly to the dashboard, such as: &lt; % = link &quot;Storybook&quot; , to : live_storybook_path ( conn , :home ) % &gt; Note you should only use link/2 to link to the storybook (and not live_redirect/live_link , as it has to set its own session on first render. Options :otp_app - Required - OTP Name of your Phoenix application. It must match :otp_app of your backend module and settings. :backend_module - Required - Name of your backend module. :live_socket_path - Configures the socket path. It must match the socket &quot;/live&quot;, Phoenix.LiveView.Socket in your endpoint. Usage # lib/my_app_web/router.ex use MyAppWeb , :router import PhxLiveStorybook.Router ... scope &quot;/&quot; do pipe_through :browser live_storybook &quot;/storybook&quot; , otp_app : :my_app , backend_module : MyAppWeb.Storybook end","ref":"PhxLiveStorybook.Router.html#live_storybook/2","title":"PhxLiveStorybook.Router.live_storybook/2","type":"macro"},{"doc":"A variation is an example of how your component can be used. Each variation will be displayed in the storybook as a code snippet alongside with the component preview. Usage def variations do [ % Variation { id : :default , description : &quot;Default dropdown&quot; , attributes : %{ label : &quot;A dropdown&quot; , } , slots : &quot;&quot;&quot; &lt;:entry path=&quot;#&quot; label=&quot;Account settings&quot;/&gt; &lt;:entry path=&quot;#&quot; label=&quot;Support&quot;/&gt; &lt;:entry path=&quot;#&quot; label=&quot;License&quot;/&gt; &quot;&quot;&quot; } ] end","ref":"PhxLiveStorybook.Variation.html","title":"PhxLiveStorybook.Variation","type":"module"},{"doc":"A variation group is a set of similar variations that will be rendered together in a single preview &lt;pre&gt; block. Usage def variations do [ % VariationGroup { id : colors , description : &quot;Different color buttons&quot; , variations : [ % Variation { id : :blue_button , attributes : %{ label : &quot;A button&quot; , color : :blue } } , % Variation { id : :red_button , attributes : %{ label : &quot;A button&quot; , color : :red } } , % Variation { id : :green_button , attributes : %{ label : &quot;A button&quot; , color : :green } } ] } ] end","ref":"PhxLiveStorybook.VariationGroup.html","title":"PhxLiveStorybook.VariationGroup","type":"module"},{"doc":"📚 Online Documentation &amp;nbsp; - &amp;nbsp; 🔎 Online Demo PhxLiveStorybook provides a storybook-like UI interface for your Phoenix LiveView components. Explore all your components, and showcase them with different variations. Browse your components documentation, with their supported attributes ( soon ). Learn how components behave by using an interactive playground ( soon ).","ref":"readme.html","title":"PhxLiveStorybook","type":"extras"},{"doc":"PhxLiveStorybook is mounted in your application router and serves its UI at the mounting point of your choice. It performs an automatic discovery of your storybook content under a specified folder ( :content_path ) and then automatically generate storybook navigation sidebar. Every module detected in your content folder, will be loaded and identified as a storybook entry. Three kind of entries are supported: component to describe your stateless function components. live_component to describe your live components. page to write &amp; document UI guidelines, or whatever content you want. Almost everything, from sidebar rendering to component preview, is performed at compilation time.","ref":"readme.html#how-does-it-work","title":"PhxLiveStorybook - How does it work?","type":"extras"},{"doc":"To start using PhxLiveStorybook in your phoenix application you will need to follow these steps: Add the phx_live_storybook dependency Create your storybook backend module Add storybook access in your router Make your components assets available Configure your storybook Create some content. 1. Add the phx_live_storybook dependency Add the following to your mix.exs and run mix deps.get: def deps do [ { :phx_live_storybook , &quot;~&gt; 0.2.0&quot; } ] end 2. Create your storybook backend module Create a new module under your application lib folder. # lib/my_app_web/storybook.ex defmodule MyAppWeb.Storybook do use PhxLiveStorybook , otp_app : :my_app end This backend module ensures the storybook gets recompiled as soon as you update your storybook content (see section 5.) 3. Add storybook access in your router Once installed, update your router's configuration to forward requests to a PhxLiveStorybook with a unique name of your choosing: # lib/my_app_web/router.ex use MyAppWeb , :router import PhxLiveStorybook.Router ... scope &quot;/&quot; do pipe_through :browser live_storybook &quot;/storybook&quot; , otp_app : :my_app , backend_module : MyAppWeb.Storybook end 4. Make your components assets available Build a new css bundle dedicated to your live_view components: this bundle will be used both by your app and the storybook. In this README, we use assets/css/my_components.css as an example. If your components require any hooks or custom uploaders, declare them as such in a new JS bundle: // assets/js/my_components.js import * as Hooks from &quot;./hooks&quot;; import * as Uploaders from &quot;./uploaders&quot;; (function () { window.storybook = { Hooks, Uploaders }; })(); 5. Configure your storybook In your configuration files, add the following. # config/config.exs config :my_app , MyAppWeb.Storybook , content_path : Path . expand ( &quot;../my_app_web/lib/storybook&quot; , __DIR__ ) , css_path : &quot;/assets/my_components.css&quot; , js_path : &quot;/assets/my_components.js&quot; 6. Create some content. Then you can start creating some content for your storybook. Storybook can contain 3 different kind of entries : component entries : to document and showcase your components. pages : to publish some UI guidelines, framework or whatever with regular HTML content. samples : to show how your components can be used and mixed togethers in real UI pages. As of 0.2.0 , only component entries are available. Entries are described as regular Elixir modules, created under your :content_path folder. Feel free to organize them in sub-folders, as the hierarchy will be respected in your storybook sidebar. Here is an example of a stateless (function) component entry: # lib/my_app_web/storybook/components/button.ex defmodule MyAppWeb.Storybook.Components.Button do alias MyAppWeb.Components.Button # :live_component is also available use PhxLiveStorybook.Entry , :component def component , do : Button def function , do : &amp; Button . button / 1 def description , do : &quot;A simple generic button.&quot; def variations do [ % Variation { id : :default , attributes : %{ label : &quot;A button&quot; } } , % Variation { id : :green_button , attributes : %{ :label =&gt; &quot;Still a button&quot; , :&quot;bg-color&quot; =&gt; &quot;bg-green-600&quot; , :&quot;hover-bg-color&quot; =&gt; &quot;bg-green-700&quot; } } ] end end Configuration All config settings, only the :content_path key is mandatory. # config/config.exs config :my_app , MyAppWeb.Storybook , # Path to your storybook entries (required). content_path : Path . expand ( &quot;../my_app_web/lib/storybook&quot; , __DIR__ ) , # Each entry module is loaded from camelized HTTP request path (ie. `&quot;/components/button&quot;`) # prefixed by the following. Default is your backend module. entries_module_prefix : MyAppWeb.Storybook , # Path to your components stylesheet. css_path : &quot;/assets/my_components.css&quot; , # Path to your JS asset, which will be loaded just before PhxLiveStorybook&#39;s own # JS. It&#39;s mainly intended to define your own LiveView Hooks in `window.storybook.Hooks`. js_path : &quot;/assets/my_components.js&quot; , # Custom storybook title. Default is &quot;Live Storybook&quot;. title : &quot;My Live Storybook&quot; , # Folder settings. # Each folder is designated by its relative path from the storybook mounting point. # For each folder you can: # - make it open by defaut in the sidebar, with `open: true`. # - give it a custom name in the sidebar # - give it a custom icon in the sidebar, with a FontAwesome 6+ CSS class. folders : [ &quot;/&quot; : [ icon : &quot;fas fa-banana&quot; ] , &quot;/components&quot; : [ icon : &quot;far fa-toolbox&quot; , open : true ] , &quot;components/live&quot; : [ icon : &quot;fal fa-bolt&quot; , name : &quot;Live!!!&quot; ] ] License MIT License. Copyright (c) 2022 Christian Blavier","ref":"readme.html#installation","title":"PhxLiveStorybook - Installation","type":"extras"}]